## freetds 1.3.17+ds

=== CMakeLists.txt ===
project(FreeTDS)

cmake_minimum_required(VERSION 3.3)

option(WITH_OPENSSL        "Link in OpenSSL if found" ON)
option(ENABLE_ODBC_WIDE    "Enable ODBC wide character support" ON)
option(ENABLE_KRB5         "Enable Kerberos support" OFF)
option(ENABLE_ODBC_MARS    "Enable MARS" ON)
option(ENABLE_EXTRA_CHECKS "Enable internal extra checks, DO NOT USE in production" OFF)

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
	cmake_policy(SET CMP0005 NEW)
endif(COMMAND cmake_policy)

set(PACKAGE freetds)
unset(VERSION)
if(EXISTS "${CMAKE_SOURCE_DIR}/configure")
	file(STRINGS "${CMAKE_SOURCE_DIR}/configure" VER LIMIT_COUNT 1 REGEX "^[ 	]*VERSION[ 	]*=.*1[.]")
	if(VER MATCHES "VERSION[ 	]*=[ 	]*'?([^' 	]+)")
		set(VERSION ${CMAKE_MATCH_1})
	endif()
else()
	file(STRINGS "${CMAKE_SOURCE_DIR}/configure.ac" VER LIMIT_COUNT 1 REGEX "^AC_INIT\\(FreeTDS,[ 	]*1[.].*\\)$")
	if(VER MATCHES "AC_INIT\\(FreeTDS,[ 	]*(.+)\\)$")
		set(VERSION ${CMAKE_MATCH_1})
	endif()
endif()
if(DEFINED VERSION)
# versions to test
#	set(VERSION "0.92.dev.esyscmd(printf $(date +\"%Y%m%d\"))")
#	set(VERSION "0.92.dev.esyscmd(printf $(date +\"%y%m%d\"))") # FAIL
#	set(VERSION "0.95rc1")
#	set(VERSION "0.95")
#	set(VERSION "0.95.1")
	string(TIMESTAMP DATE "%Y%m%d")
	string(REPLACE ".esyscmd(printf $(date +\"%Y%m%d\"))" ".${DATE}" VERSION ${VERSION})
	string(REGEX REPLACE "^dev\\.([0-9]+\\.[0-9]+)\\." "\\1.dev." VERSION "${VERSION}")
	string(REGEX REPLACE "^([0-9]+\\.[0-9]+)(rc|RC)" "\\1.dev." VER "${VERSION}")
	string(REPLACE ".dev." ".9999." VER ${VER})
	if(VER MATCHES "[^0-9.]" OR VER MATCHES "\\.\\.")
		message(FATAL_ERROR "wrong VERSION format (${VERSION}) --> (${VER})")
	endif()
	if("${VER}.0" MATCHES "^([0-9]+)\\.([0-9]+)\\.([0-9]+)")
		set(MAJOR ${CMAKE_MATCH_1})
		set(MINOR ${CMAKE_MATCH_2})
		set(SUBVERSION ${CMAKE_MATCH_3})
		if(SUBVERSION STREQUAL "9999")
			math(EXPR MINOR "${MINOR} - 1")
		endif()
	else()
		message(FATAL_ERROR "wrong VERSION format (${VERSION}) --> (${VER})")
	endif()
#	message(FATAL_ERROR "DEBUG ${MAJOR} ${MINOR} ${SUBVERSION}")
else()
	message(FATAL_ERROR "VERSION not found or wrong format")
endif()

# get build number from date
# use same formula used in configure.ac
unset(BUILD_NUMBER)
string(TIMESTAMP BUILD_NUMBER "( %Y - 2021 ) * 366 + 1%j - 1000")
math(EXPR BUILD_NUMBER "${BUILD_NUMBER}")

set(FREETDS_TOPDIR ${CMAKE_CURRENT_LIST_DIR})

enable_testing()
set(CMAKE_CTEST_COMMAND ctest)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

# TODO depends on configure
add_definitions(-D_REENTRANT -D_THREAD_SAFE)

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckPrototypeDefinition)

find_package(Perl)
find_program(GPERF NAMES gperf)

macro(config_write str)
	file(APPEND "${CMAKE_BINARY_DIR}/include/config.h.in" "${str}")
endmacro()

file(WRITE "${CMAKE_BINARY_DIR}/include/config.h.in" "/* Automatic generated by cmake */\n\n#define _freetds_config_h_\n")

foreach(fn
	arpa/inet.h
	com_err.h
	dirent.h
	errno.h
	getopt.h
	inttypes.h
	langinfo.h
	libgen.h
	limits.h
	locale.h
	malloc.h
	netdb.h
	netinet/in.h
	netinet/tcp.h
	paths.h
	poll.h
	roken.h
	signal.h
	sql.h
	sqlext.h
	stddef.h
	stdlib.h
	stdint.h
	string.h
	strings.h
	sys/eventfd.h
	sys/ioctl.h
	sys/param.h
	sys/resource.h
	sys/select.h
	sys/socket.h
	sys/stat.h
	sys/time.h
	sys/types.h
	sys/wait.h
	unistd.h
	fcntl.h
	wchar.h
	windows.h)

	string(REGEX REPLACE "[/.]" "_" var "${fn}")
	string(TOUPPER "HAVE_${var}" var)
	CHECK_INCLUDE_FILE(${fn} ${var})
	config_write("/* Define to 1 if you have the <${fn}> header file. */\n")
	config_write("#cmakedefine ${var} 1\n\n")
endforeach(fn)

macro(CHECK_FUNCTION_EXISTS_DEFINE func)
	string(TOUPPER "HAVE_${func}" var)
	check_function_exists(${func} ${var})
	config_write("/* Define to 1 if you have function <${func}>. */\n")
	config_write("#cmakedefine ${var} 1\n\n")
endmacro()

if(WITH_OPENSSL)
	find_package(OpenSSL)
endif(WITH_OPENSSL)
if(OPENSSL_FOUND)
	config_write("#define HAVE_OPENSSL 1\n\n")
	include_directories(${OPENSSL_INCLUDE_DIR})
	set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
	# This fixes an issue with OpenSSL compiled as static library
	if(WIN32)
		list(APPEND CMAKE_REQUIRED_LIBRARIES crypt32 ws2_32)
	endif(WIN32)
	check_function_exists_define(BIO_get_data)
	check_function_exists_define(RSA_get0_key)
	check_function_exists_define(ASN1_STRING_get0_data)
	set(CMAKE_REQUIRED_LIBRARIES)
endif(OPENSSL_FOUND)

set(CMAKE_THREAD_PREFER_PTHREAD ON)
find_package(Threads REQUIRED)

if(HAVE_WINDOWS_H)
	if(NOT HAVE_SQL_H)
		unset(HAVE_SQL_H CACHE)
		CHECK_INCLUDE_FILES("windows.h;sql.h" HAVE_SQL_H)
	endif()
	if(HAVE_SQL_H AND NOT HAVE_SQLEXT_H)
		unset(HAVE_SQLEXT_H CACHE)
		CHECK_INCLUDE_FILES("windows.h;sql.h;sqlext.h" HAVE_SQLEXT_H)
	endif()
	if(NOT HAVE_ODBCSS_H)
		unset(HAVE_ODBCSS_H CACHE)
		CHECK_INCLUDE_FILES("windows.h;sqltypes.h;odbcss.h" HAVE_ODBCSS_H)
	endif()
endif(HAVE_WINDOWS_H)

# find types
macro(ADD_HEADER VAR FN)
	if(${VAR})
		set(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} ${FN})
	endif()
endmacro(ADD_HEADER)

add_header(HAVE_WCHAR_H wchar.h)
add_header(HAVE_WINDOWS_H windows.h)
add_header(HAVE_SQL_H sql.h)
add_header(HAVE_SQLEXT_H sqlext.h)
foreach(fn char double float int short long "long double" "long long" "SQLWCHAR" "void *" wchar_t __int64
	  SQLLEN SQLROWOFFSET SQLROWSETSIZE SQLSETPOSIROW)
	string(REGEX REPLACE "[/. ]" "_" var "${fn}")
	string(REPLACE "*" "P" var "${var}")
	string(TOUPPER "HAVE_${var}" have)
	string(TOUPPER "SIZEOF_${var}" var)
	CHECK_TYPE_SIZE(${fn} ${var})
	if(HAVE_${var})
		set(${have} 1 CACHE INTERNAL "Have type ${fn}")
	else()
		set(${var} 0)
	endif()
	config_write("#define ${var} \\@${var}\\@\n\n")
endforeach(fn)

foreach(fn SQLLEN SQLROWOFFSET SQLROWSETSIZE SQLSETPOSIROW)
	config_write("/* Define to 1 if you have type <${fn}>. */\n#cmakedefine HAVE_${fn} 1\n\n")
endforeach(fn)

check_prototype_definition(SQLColAttribute
"SQLRETURN  SQL_API SQLColAttribute (SQLHSTMT StatementHandle,
	SQLUSMALLINT ColumnNumber, SQLUSMALLINT FieldIdentifier,
	SQLPOINTER CharacterAttribute, SQLSMALLINT BufferLength,
	SQLSMALLINT *StringLength, SQLLEN * NumericAttribute)"
	SQL_SUCCESS
	"${CMAKE_EXTRA_INCLUDE_FILES}"
	TDS_SQLCOLATTRIBUTE_SQLLEN)
config_write("/* Define to 1 if last argument of SQLColAttribute it's SQLLEN * */\n#cmakedefine TDS_SQLCOLATTRIBUTE_SQLLEN 1\n\n")

check_prototype_definition(SQLParamOptions
	"SQLRETURN SQL_API SQLParamOptions(SQLHSTMT hstmt, SQLULEN crow, SQLULEN *pirow)"
	SQL_SUCCESS
	"${CMAKE_EXTRA_INCLUDE_FILES}"
	TDS_SQLPARAMOPTIONS_SQLLEN)
config_write("/* Define to 1 if SQLParamOptions accept SQLULEN as arguments */\n#cmakedefine TDS_SQLPARAMOPTIONS_SQLLEN 1\n\n")

set(CMAKE_EXTRA_INCLUDE_FILES)

macro(SELECT_TYPE VAR SIZE TYPES ERROR)
	set(${VAR} "")
	foreach(t ${TYPES})
		string(REGEX REPLACE "[/. ]" "_" var "${t}")
		string(REPLACE "*" "P" var "${var}")
		string(TOUPPER "SIZEOF_${var}" var)
		if(${${var}} EQUAL ${SIZE})
			set(${VAR} ${t})
			break()
		endif()
	endforeach(t)
	if(${VAR} STREQUAL "")
		message(FATAL_ERROR ${ERROR})
	endif()
endmacro(SELECT_TYPE)

SELECT_TYPE(tds_sysdep_int16_type 2 "short;int" "No 16-bit int found.")
SELECT_TYPE(tds_sysdep_int32_type 4 "short;int;long" "No 32-bit int found.")
SELECT_TYPE(tds_sysdep_int64_type 8 "long;long long;__int64" "No 64-bit int found.")
SELECT_TYPE(tds_sysdep_real32_type 4 "float;double" "No 32-bit real found.")
SELECT_TYPE(tds_sysdep_real64_type 8 "float;double;long double" "No 64-bit real found.")
SELECT_TYPE(tds_sysdep_intptr_type ${SIZEOF_VOID_P} "short;int;long;__int64" "No intptr type found.")

# find functions
set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
set(FUNCS asprintf vasprintf strtok_r strtok_s readpassphrase
	strlcpy strlcat basename getopt strsep
	vsnprintf _vsnprintf snprintf _snprintf _vscprintf gettimeofday
	nl_langinfo locale_charset setenv putenv
	getuid getpwuid getpwuid_r fstat alarm fork
	gethrtime localtime_r setitimer
	_fseeki64 _ftelli64 setrlimit
	inet_ntoa_r getipnodebyaddr getipnodebyname
	getaddrinfo inet_ntop gethostname poll socketpair
	clock_gettime fseeko pthread_cond_timedwait pthread_cond_timedwait_relative_np
	pthread_condattr_setclock _lock_file _unlock_file usleep nanosleep
	readdir_r eventfd daemon system)

# TODO
set(HAVE_GETADDRINFO 1 CACHE INTERNAL "")

foreach(func ${FUNCS})
	check_function_exists_define(${func})
endforeach(func)

macro(CHECK_STDIO_FUNCTION_EXISTS FUNCTION)
	string(TOUPPER "HAVE_${FUNCTION}" VARIABLE)
	string(TOUPPER "CHECK_${FUNCTION}" CHECK)
	if (NOT ${VARIABLE})
		set(MACRO_CHECK_FUNCTION_DEFINITIONS
			"-D${CHECK}=1 ${CMAKE_REQUIRED_FLAGS}")
		message(STATUS "Looking for ${FUNCTION}")
		try_compile(${VARIABLE}
			${CMAKE_BINARY_DIR}
			${CMAKE_SOURCE_DIR}/misc/cmake_checks.c
			COMPILE_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS}
			CMAKE_FLAGS -DCOMPILE_DEFINITIONS:STRING=${MACRO_CHECK_FUNCTION_DEFINITIONS}
			OUTPUT_VARIABLE OUTPUT)
		if(${VARIABLE})
			set(${VARIABLE} 1 CACHE INTERNAL "Have function ${FUNCTION}")
			message(STATUS "Looking for ${FUNCTION} - found")
			file(APPEND ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeOutput.log
				"Determining if the function ${FUNCTION} exists passed with the following output:\n"
				"${OUTPUT}\n\n")
		else()
			message(STATUS "Looking for ${FUNCTION} - not found")
			set(${VARIABLE} "" CACHE INTERNAL "Have function ${FUNCTION}")
			file(APPEND ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeError.log
				"Determining if the function ${FUNCTION} exists failed with the following output:\n"
				"${OUTPUT}\n\n")
		endif()
	endif()
endmacro()

foreach(func asprintf vasprintf vsnprintf _vsnprintf snprintf _snprintf _vscprintf)
	check_stdio_function_exists(${func})
endforeach(func)

set(CMAKE_REQUIRED_LIBRARIES)

check_struct_has_member("struct tm" "tm_zone" "time.h" HAVE_STRUCT_TM_TM_ZONE)
config_write("#cmakedefine HAVE_STRUCT_TM_TM_ZONE 1\n\n")

macro(SEARCH_LIBRARY FUNC HAVE VAR LIBS)
	foreach(lib ${LIBS})
		if(NOT ${HAVE})
			unset(${HAVE} CACHE)
			check_library_exists(${lib} ${FUNC} "" ${HAVE})
			if(${HAVE})
				unset(${VAR} CACHE)
				set(${VAR} ${lib} CACHE INTERNAL "")
			endif()
		endif()
	endforeach(lib)
endmacro(SEARCH_LIBRARY)

check_library_exists(readline readline "" HAVE_READLINE)
if(HAVE_READLINE)
	config_write("#cmakedefine HAVE_READLINE 1\n\n")
	search_library(tgetent HAVE_TGETENT lib_READLINE "readline;ncurses;curses;termcap")
	set(lib_READLINE readline ${lib_READLINE})
endif(HAVE_READLINE)

config_write("#cmakedefine HAVE_SQLGETPRIVATEPROFILESTRING 1\n\n")
if(WIN32)
	set(lib_ODBCINST odbccp32)
	check_library_exists(legacy_stdio_definitions _vsnwprintf_s "" LEGACY_STDIO)
	if(LEGACY_STDIO)
		set(lib_ODBCINST ${lib_ODBCINST} legacy_stdio_definitions)
	endif(LEGACY_STDIO)
else()
	search_library(SQLGetPrivateProfileString HAVE_SQLGETPRIVATEPROFILESTRING lib_ODBCINST "odbcinst;iodbcinst")
endif()

# flags
foreach(flag ODBC_WIDE EXTRA_CHECKS KRB5 ODBC_MARS)
	config_write("#cmakedefine ENABLE_${flag} 1\n\n")
endforeach(flag)

config_write("#define VERSION \"\\@VERSION\\@\"\n\n")

config_write("#define FREETDS_TOPDIR \"${FREETDS_TOPDIR}\"\n\n")

# TODO allow to configure default TDS protocol version

config_write("#ifdef _MSC_VER
#  define inline __inline
#  define _CRT_SECURE_NO_WARNINGS 1
#endif\n\n")

if(WIN32)
	config_write("/* Define to 1 if you want to use SSPI for Win32 */\n#define HAVE_SSPI 1\n\n")
	config_write("/* define to format string used for 64bit integers */\n#define TDS_I64_PREFIX \"I64\"\n\n")
	config_write("/* Define to 1 if you have the SQLGetPrivateProfileString function. */\n#define HAVE_SQLGETPRIVATEPROFILESTRING 1\n\n")
	if(MINGW)
		config_write("#define _GNU_SOURCE 1\n\n")
	endif(MINGW)

else(WIN32)
	# this section make just work on Linux, many definition are not checked
	config_write("#define HAVE_FUNC_GETPWUID_R_5 1\n\n")

=== src/odbc/CMakeLists.txt ===
add_subdirectory(unittests)

# TODO checks
add_definitions(-DUNIXODBC -DHAVE_SQLGETPRIVATEPROFILESTRING)

if(PERL_FOUND AND NOT EXISTS "${CMAKE_SOURCE_DIR}/src/odbc/odbc_export.h")
	add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/odbc_export.h"
		COMMAND ${PERL_EXECUTABLE} odbc_export.pl odbc.c > "${CMAKE_CURRENT_BINARY_DIR}/odbc_export.h"
		MAIN_DEPENDENCY odbc_export.pl
		DEPENDS odbc.c
		WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})
	add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/error_export.h"
		COMMAND ${PERL_EXECUTABLE} odbc_export.pl error.c > "${CMAKE_CURRENT_BINARY_DIR}/error_export.h"
		MAIN_DEPENDENCY odbc_export.pl
		DEPENDS error.c
		WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})
	add_custom_target(odbc_exports_h DEPENDS
		"${CMAKE_CURRENT_BINARY_DIR}/odbc_export.h"
		"${CMAKE_CURRENT_BINARY_DIR}/error_export.h")
else(PERL_FOUND AND NOT EXISTS "${CMAKE_SOURCE_DIR}/src/odbc/odbc_export.h")
	add_custom_target(odbc_exports_h DEPENDS
		"${CMAKE_CURRENT_SOURCE_DIR}/odbc_export.h"
		"${CMAKE_CURRENT_SOURCE_DIR}/error_export.h")
endif(PERL_FOUND AND NOT EXISTS "${CMAKE_SOURCE_DIR}/src/odbc/odbc_export.h")

if(WIN32)
	set(win_SRCS winlogin.c winsetup.c winmain.c odbc_w.def setup.rc)
endif()
set(libs ${lib_ODBCINST})

add_library(tdsodbc SHARED
	odbc.c connectparams.c convert_tds2sql.c
	descriptor.c prepare_query.c odbc_util.c bcp.c
	native.c sql2tds.c error.c odbc_checks.c sqlwchar.c sqlwparams.h
	odbc_data.c ${win_SRCS}
)
target_include_directories(tdsodbc PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")
add_dependencies(tdsodbc odbc_exports_h encodings_h)
target_compile_definitions(tdsodbc PUBLIC DLL_EXPORT=1)
# TODO libiconv, odbcinstlib and other dynamics
target_link_libraries(tdsodbc tds replacements tdsutils ${libs} ${lib_NETWORK} ${lib_BASE})

if(MINGW OR CYGWIN)
	set_target_properties(tdsodbc PROPERTIES LINK_FLAGS "--static -Wl,--kill-at -Wl,--enable-stdcall-fixup")
endif(MINGW OR CYGWIN)

add_library(tdsodbc_static STATIC
	odbc.c connectparams.c convert_tds2sql.c
	descriptor.c prepare_query.c odbc_util.c bcp.c
	native.c sql2tds.c error.c odbc_checks.c sqlwchar.c sqlwparams.h
	odbc_data.c ${win_SRCS}
)
target_include_directories(tdsodbc_static PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")
add_dependencies(tdsodbc_static odbc_exports_h encodings_h)
if (NOT WIN32)
	set_target_properties(tdsodbc_static PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

INSTALL(TARGETS tdsodbc
	PUBLIC_HEADER DESTINATION include
		RUNTIME DESTINATION bin
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
	)

=== src/utils/CMakeLists.txt ===
add_subdirectory(unittests)

if(WIN32)
	set(add_SRCS md5.c)
else(WIN32)
	set(add_SRCS md4.c md5.c des.c hmac_md5.c)
endif(WIN32)

add_library(tdsutils STATIC
	dlist.c
	getpassarg.c
	sleep.c
	tds_cond.c
	win_mutex.c
	threadsafe.c
	bjoern-utf8.c
	tdsstring.c
	net.c
	${add_SRCS}
)
if (NOT WIN32)
	set_target_properties(tdsutils PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(WIN32)
INSTALL(TARGETS tdsutils
	PUBLIC_HEADER DESTINATION include
		RUNTIME DESTINATION bin
		LIBRARY DESTINATION lib
		ARCHIVE DESTINATION lib
	)
endif(WIN32)

=== src/ctlib/unittests/CMakeLists.txt ===
add_library(c_common STATIC common.c common.h)

foreach(target t0001 t0002 t0003 t0004
	t0005 cs_convert t0007 t0008
	t0009 connect_fail ct_options
	lang_ct_param array_bind cs_diag
	get_send_data rpc_ct_param rpc_ct_setparam
	ct_diagclient ct_diagserver ct_diagall
	cs_config cancel blk_in
	blk_out ct_cursor ct_cursors
	ct_dynamic blk_in2 datafmt data
	all_types long_binary will_convert
	variant)
	add_executable(c_${target} EXCLUDE_FROM_ALL ${target}.c)
	set_target_properties(c_${target} PROPERTIES OUTPUT_NAME ${target})
	if (target STREQUAL "all_types")
		target_link_libraries(c_${target} c_common ct-static t_common tds replacements tdsutils ${lib_NETWORK} ${lib_BASE})
	else()
		target_link_libraries(c_${target} c_common ct replacements tdsutils ${lib_NETWORK} ${lib_BASE})
	endif()
	add_test(NAME c_${target} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMAND c_${target})
	add_dependencies(check c_${target})
endforeach(target)

=== src/dblib/unittests/CMakeLists.txt ===
add_library(d_common STATIC common.c common.h)

foreach(target t0001 t0002 t0003 t0004 t0005 t0006 t0007 t0008 t0009
	t0011 t0012 t0013 t0014 t0015 t0016 t0017 t0018 t0019 t0020
	dbsafestr t0022 t0023 rpc dbmorecmds bcp thread text_buffer
	done_handling timeout hang null null2 setnull numeric pending
	cancel spid canquery batch_stmt_ins_sel batch_stmt_ins_upd bcp_getl
	empty_rowsets string_bind colinfo bcp2)
	add_executable(d_${target} EXCLUDE_FROM_ALL ${target}.c)
	set_target_properties(d_${target} PROPERTIES OUTPUT_NAME ${target})
	target_link_libraries(d_${target} d_common sybdb replacements tdsutils ${lib_NETWORK} ${lib_BASE})
	add_test(NAME d_${target} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMAND d_${target})
	add_dependencies(check d_${target})
endforeach(target)

=== src/tds/unittests/CMakeLists.txt ===
include_directories(..)

add_library(t_common STATIC common.c common.h utf8.c allcolumns.c)

foreach(target t0001 t0002 t0003 t0004 t0005 t0006 t0007 t0008 dynamic1
    convert dataread utf8_1 utf8_2 utf8_3 numeric iconv_fread toodynamic
    readconf collations corrupt declarations portconf
    parsing freeze strftime log_elision)
	add_executable(t_${target} EXCLUDE_FROM_ALL ${target}.c)
	set_target_properties(t_${target} PROPERTIES OUTPUT_NAME ${target})
	target_link_libraries(t_${target} t_common tds replacements tdsutils ${lib_NETWORK} ${lib_BASE})
	if(NOT ${target} STREQUAL "collations")
		add_test(NAME t_${target} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMAND t_${target})
	endif()
	add_dependencies(check t_${target})
endforeach(target)

=== src/utils/unittests/CMakeLists.txt ===
include_directories(..)

if(NOT WIN32)
	set(unix_TESTS challenge)
endif(NOT WIN32)

foreach(target passarg condition mutex1 dlist bytes ${unix_TESTS})
	add_executable(u_${target} EXCLUDE_FROM_ALL ${target}.c)
	set_target_properties(u_${target} PROPERTIES OUTPUT_NAME ${target})
	target_link_libraries(u_${target} tdsutils ${lib_NETWORK} ${lib_BASE})
	add_test(NAME u_${target} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMAND u_${target})
	add_dependencies(check u_${target})
endforeach(target)

=== debian/changelog ===
freetds (1.3.17+ds-2+deb13u1) trixie; urgency=medium

  * debian/patches: Add upstream patch to fix float -> uint conversion bounds
    check (Closes: #1104758)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 Jul 2025 10:08:11 +0200

freetds (1.3.17+ds-2) unstable; urgency=medium

  * source-only upload to enable bookwork testing migration. 

 -- Joseph Nahmias <jello@debian.org>  Thu, 26 Jan 2023 19:59:14 -0500

freetds (1.3.17+ds-1) unstable; urgency=medium

  * [67ac20b] new maintainer.
    Thanks to Steve Langasek for all your work on this package!
  * [3f141a9] update Vcs headers to point to salsa repo in debian namespace
  * [6123606] use DEP-14 branch naming
  * [68f9eda] enable salsa-ci pipeline
  * [12dcee9] New upstream version 1.3.13
  * [4a2dcc9] drop conflicts/breaks/replaces on ancient packages
    these have not been seen since before jessie, released on 2015-04-26
  * [2ecf8b2] default yes to registering the odbc driver; add dep on odbcinst
  * [5f529a7] declare that we are using deb source format 3.0 (quilt)
  * [299a8b5] New upstream version 1.3.17
  * [7f4a341] interim changelog update
  * [52e3272] add back patch to drop AC_LTDL_DLLIB via quilt
  * [bf40df5] install freetds.conf(5)
  * [e6da50b] don't try to install freetds.conf.pl; it's no longer shipped
    by upstream
  * [5f615c3] drop obsolete version requirement for unixodbc-dev
  * [e062698] replace pkg-config with pkgconf
  * [835ad2b] build documentation and place it in new freetds-doc pkg
  * [d000ae1] mark *.la as deliberately not-installed
  * [ed09e5c] update lintian override to new syntax
  * [8e83767] repack upstream tarball to exclude generated documentation
  * [844d9c3] New upstream version 1.3.17+ds
  * [a63b976] add myself to debian/* copyright
  * [2486e5c] tell lintian that the TDS Protocol HTML is the source
  * [2214cb1] install TDS protocol docs in the freetds-doc pkg
  * [a7ec02f] per lintian, remove hotlink to w3c validation icon
  * [3ad1e59] update copyright info to be more complete
  * [d4db0aa] fix installation of {locales,pool}.conf examples

 -- Joseph Nahmias <jello@debian.org>  Wed, 25 Jan 2023 21:38:17 -0500

freetds (1.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Replace reference to obsolete AC_LTDL_DLLIB.  Closes: #1002140.
  * Drop unused build-dependency on libglib2.0-dev.  Closes: #981651.
  * Remove Adam from the uploaders list; RIP.  Closes: #986950.
  * Drop obsolete build-dependency on autotools-dev.
  * Upgrade to debhelper-compat (= 12).
  * Drop obsolete --parallel argument to dh.
  * Update Standards-Version.

 -- Steve Langasek <vorlon@debian.org>  Sat, 15 Jan 2022 06:24:24 +0000

freetds (1.2.3-1) unstable; urgency=medium

  * New upstream release.
    - documentation files renamed to .md.

 -- Steve Langasek <vorlon@debian.org>  Sat, 15 Aug 2020 05:12:32 +0000

freetds (1.1.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * tds: Make sure UDT has varint set to 8 (CVE-2019-13508) (Closes: #944012)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 01 Jan 2020 21:09:16 +0100

freetds (1.1.6-1) unstable; urgency=medium

  * New upstream release.
    - Fixes ppc64el compatibility.  LP: #1826851.
    - Update libsybdb5.symbols for new upstream.
  * Stop specifying 4.2 as the default protocol, now obsoleted upstream.
    Allow the upstream default instead of autodetecting the default TDS
    protocol version.

 -- Steve Langasek <vorlon@debian.org>  Thu, 02 May 2019 02:57:34 +0000

freetds (1.00.104-1) unstable; urgency=medium

  * New upstream release.

 -- Steve Langasek <vorlon@debian.org>  Thu, 18 Oct 2018 23:43:49 -0700

freetds (1.00.82-2) unstable; urgency=medium

  * Fix arch-any builds.  Closes: #890888.

 -- Steve Langasek <vorlon@debian.org>  Tue, 20 Feb 2018 23:46:25 +0000

freetds (1.00.82-1) unstable; urgency=medium

  * Update Vcs-* fields.
  * Fix watch file.
  * New upstream release.  Closes: #803258, LP: #1679975.
    - Fixes login when using long (> 30 char) passwords.  Closes: #706388.
    - Fixes an intermittent connection failure to MSSQL.  LP: #1727572.
    - Fixes a crash when connecting to a non-TDS server.  LP: #1215336.
    - Update symbols files.
  * Update Standards-Version.
  * Update debian/copyright.
  * Fix upstream spelling; thanks, Lintian
  * Drop Conflicts against obsolete versions of unixodbc; lintian complains
    about versioned conflicts, the rationale is lost in the mists of time,
    and this is shadowed by an existing Breaks: against newer versions of
    unixodbc anyway.
  * Fix permissions on /usr/share/freetds/freetds.conf.
  * Fix wrong empty dirs in freetds-common.
  * Fix manpage warnings.
  * Add some lintian overrides.
  * Build-depend on pkg-config; upstream now uses PKG_PROG_PKG_CONFIG, so
    this is the only piece left to support cross-building.  Closes: #873712.
  * Bump debhelper compat to 10, and drop explicit dh-autoreconf dep since
    this is now automatic.

 -- Steve Langasek <vorlon@debian.org>  Tue, 20 Feb 2018 04:38:05 +0000

freetds (0.91-6.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use gnutls_priority_set_direct with a priority string of NORMAL:%COMPAT
    instead of deprecated gnutls_{cipher,kx,...}_set_priority functions. This
    uses the same priority string as 7ca9321ff440814581a8ec87984f7d76f8cc105e
    from upstream GIT, except for not disabling SSL3.0 since Debian's GnuTLS
    does not enable SSL3 by default. Closes: #782818

 -- Andreas Metzler <ametzler@debian.org>  Sun, 26 Jul 2015 18:06:25 +0200

freetds (0.91-6) unstable; urgency=low

  * Build against libgnutls28, now that license compatibility issues
    with GPLv2-only software have been resolved.  This includes patching
    the upstream source to not look for gcrypt, which is no longer needed.
    Thanks to Dimitri Ledkov <dimitri.ledkov@canonical.com> for the patch.
    Closes: #747449.

 -- Steve Langasek <vorlon@debian.org>  Thu, 08 May 2014 15:25:40 -0700



=== debian/control ===
Source: freetds
Section: libs
Priority: optional
Maintainer: Joseph Nahmias <jello@debian.org>
Standards-Version: 4.6.0
Homepage: http://www.freetds.org/
Vcs-Git: https://salsa.debian.org/debian/freetds.git
Vcs-Browser: https://salsa.debian.org/debian/freetds
Build-Depends: debhelper-compat (= 12),
	unixodbc-dev,
	libgnutls28-dev,
	libreadline-dev,
	libkrb5-dev,
	pkgconf,
Build-Depends-Indep:
	doxygen <!nodoc>,
	xmlto <!nodoc>,

Package: freetds-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: configuration files for FreeTDS SQL client libraries
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package manages the configuration files that are common to all of
 the TDS client library implementations (CT-Lib, DB-Lib, and ODBC),
 stored in /etc/freetds/.

Package: libct4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, freetds-common, ${misc:Depends}
Description: libraries for connecting to MS SQL and Sybase SQL servers
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the shared libraries for the Sybase CT-Lib API.
 You will need this if you plan to connect to MS SQL or Sybase servers, or use
 the PHP sybase or Perl DBD::Sybase extensions.

Package: freetds-bin
Architecture: any
Section: database
Depends: ${shlibs:Depends}, freetds-common, ${misc:Depends}
Suggests: freetds-doc
Description: FreeTDS command-line utilities
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the command-line utilities shipped with FreeTDS.

Package: tdsodbc
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, freetds-common, odbcinst, ${misc:Depends}
Recommends: libodbc1
Description: ODBC driver for connecting to MS SQL and Sybase SQL servers
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the ODBC driver for FreeTDS, for use with
 UnixODBC or iODBC.

Package: libsybdb5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, freetds-common, ${misc:Depends}
Description: libraries for connecting to MS SQL and Sybase SQL servers
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the shared libraries for the Sybase DB-Lib API.

Package: freetds-dev
Section: devel
Architecture: any
Depends: libct4 (= ${binary:Version}), libsybdb5 (= ${binary:Version}), ${misc:Depends}
Recommends: freetds-doc
Description: MS SQL and Sybase client library (static libs and headers)
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the static libraries and header files for TDS, which
 you will need to develop applications that connect to MS SQL servers.  You
 will also need this package if you are installing the Perl DBD::Sybase
 module on your system using CPAN.

Package: freetds-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: FreeTDS documentation
 FreeTDS is an implementation of the Tabular DataStream protocol, used for
 connecting to MS SQL and Sybase servers over TCP/IP.
 .
 This package includes the user guide as well as the library API reference
 manual.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND = -Wall -DDBLIB_UNIMPLEMENTED=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --with-gnu-ld \
		--with-unixodbc=/usr --sysconfdir=/etc/freetds \
		--enable-sybase-compat --with-gnutls --enable-krb5

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/odbc
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libtdsodbc.so.0.0.0 \
	   $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/odbc/libtdsodbc.so
	rm -f $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libtdsodbc*

override_dh_fixperms:
ifneq (,$(filter freetds-common, $(shell dh_listpackages)))
	chmod a-x $(CURDIR)/debian/freetds-common/usr/share/freetds/freetds.conf
endif
	dh_fixperms

override_dh_makeshlibs:
	dh_makeshlibs -Xtdsodbc -V

## freetds 1.5.2%2Bds

=== debian/tests/control ===
Tests: libtests
Depends:
 freetds-dev,
 gcc,
 libc6-dev | libc-dev,

## freetds 1.5.2+ds

=== debian/changelog ===
freetds (1.5.2+ds-1) unstable; urgency=medium

  * New upstream version 1.5.2+ds
  * drop patch merged upstream

 -- Joseph Nahmias <jello@debian.org>  Sun, 01 Jun 2025 08:08:41 -0400

freetds (1.5.1+ds-3) unstable; urgency=medium

  * add upstream patch to fix float -> uint conversion bounds check
    (Closes: #1104758)
  * clean up after running tests

 -- Joseph Nahmias <jello@debian.org>  Sat, 31 May 2025 23:05:21 -0400

freetds (1.5.1+ds-2) unstable; urgency=medium

  [ Carles Pina i Estany ]
  * Added po-debconf Catalan translation (Closes: #1101118)

  [ Joseph Nahmias ]
  * bump Std-Ver; no changes
  * fix dep5 syntax error
  * remove outdated FSF address
  * fix reproducibility of documentation build.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>
    (Closes: #1037269)
  * tdsodbc: change recommends from libodbc1 to libodbc2.
    Thanks to Hugh McMaster <hugh.mcmaster@outlook.com> (Closes: #1025534)
  * d/clean: remove stray testing artifact (Closes: #1044723)
  * add Romanian debconf template translation.
    Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>
    (Closes: #1102144)
  * debhelper compat 12 -> 13
  * add copyright for new Catalan translation
  * add some simple autopkgtests
  * add missing libc6-dev dep for autopkgtest
  * fix dep5 copyright syntax for public domain files

 -- Joseph Nahmias <jello@debian.org>  Thu, 24 Apr 2025 23:24:21 -0400

freetds (1.5.1+ds-1) unstable; urgency=medium

  * New upstream version 1.4.14+ds
  * drop patch merged upstream
  * New upstream version 1.5+ds
  * update build/test recipe for v1.5
  * New upstream version 1.5.1+ds
  * skip network tests
  * enable build-any job in salsa-ci

 -- Joseph Nahmias <jello@debian.org>  Wed, 23 Apr 2025 07:18:20 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Joseph Nahmias <jello@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Homepage: http://www.freetds.org/
 Vcs-Git: https://salsa.debian.org/debian/freetds.git
 Vcs-Browser: https://salsa.debian.org/debian/freetds
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
 	unixodbc-dev,
 	libgnutls28-dev,
 	libreadline-dev,
@@ -56,7 +56,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, freetds-common, odbcinst, ${misc:Depends}
-Recommends: libodbc1
+Recommends: libodbc2
 Description: ODBC driver for connecting to MS SQL and Sybase SQL servers
  FreeTDS is an implementation of the Tabular DataStream protocol, used for
  connecting to MS SQL and Sybase servers over TCP/IP.

## freetds 1.5.4+ds

=== debian/changelog ===
freetds (1.5.4+ds-1) unstable; urgency=medium

  * New upstream version 1.5.4+ds
  * mark autopkgtest as superficial
  * enable sending salsa-ci stats
  * do not fail the ci pipeline for reprotest - known issue with doxygen
  * enable nocheck and nodoc build profile jobs in salsa-ci
  * enable salsa ci arm64 crossbuild job
  * enable salsa ci job to build twice
  * enable generation of dbgsym packages on salsa ci
  * run wrap-and-sort -asbkt & configure salsa job accordingly

 -- Joseph Nahmias <jello@debian.org>  Mon, 18 Aug 2025 21:11:48 -0400

## freetds 1.5.5%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,13 @@
+cmake_minimum_required(VERSION 3.5)
+
 project(FreeTDS)
-
-cmake_minimum_required(VERSION 3.3)
 
 option(WITH_OPENSSL        "Link in OpenSSL if found" ON)
 option(ENABLE_ODBC_WIDE    "Enable ODBC wide character support" ON)
 option(ENABLE_KRB5         "Enable Kerberos support" OFF)
 option(ENABLE_ODBC_MARS    "Enable MARS" ON)
 option(ENABLE_EXTRA_CHECKS "Enable internal extra checks, DO NOT USE in production" OFF)
+option(ENABLE_MSDBLIB      "Enable MS style dblib" OFF)
 
 if(COMMAND cmake_policy)
 	cmake_policy(SET CMP0003 NEW)
@@ -59,7 +60,7 @@
 # get build number from date
 # use same formula used in configure.ac
 unset(BUILD_NUMBER)
-string(TIMESTAMP BUILD_NUMBER "( %Y - 2021 ) * 366 + 1%j - 1000")
+string(TIMESTAMP BUILD_NUMBER "( %Y - 2025 ) * 366 + 1%j - 1000")
 math(EXPR BUILD_NUMBER "${BUILD_NUMBER}")
 
 set(FREETDS_TOPDIR ${CMAKE_CURRENT_LIST_DIR})
@@ -78,6 +79,7 @@
 include(CheckLibraryExists)
 include(CheckStructHasMember)
 include(CheckPrototypeDefinition)
+include(GNUInstallDirs)
 
 find_package(Perl)
 find_program(GPERF NAMES gperf)
@@ -87,6 +89,11 @@
 endmacro()
 
 file(WRITE "${CMAKE_BINARY_DIR}/include/config.h.in" "/* Automatic generated by cmake */\n\n#define _freetds_config_h_\n")
+
+if(NOT WIN32)
+	file(WRITE "${CMAKE_BINARY_DIR}/include/freetds/sysconfdir.h"
+		"#define FREETDS_SYSCONFDIR \"${CMAKE_INSTALL_FULL_SYSCONFDIR}\"\n")
+endif(NOT WIN32)
 
 foreach(fn
 	arpa/inet.h
@@ -157,6 +164,7 @@
 	check_function_exists_define(BIO_get_data)
 	check_function_exists_define(RSA_get0_key)
 	check_function_exists_define(ASN1_STRING_get0_data)
+	check_function_exists_define(SSL_set_alpn_protos)
 	set(CMAKE_REQUIRED_LIBRARIES)
 endif(OPENSSL_FOUND)
 
@@ -189,7 +197,7 @@
 add_header(HAVE_WINDOWS_H windows.h)
 add_header(HAVE_SQL_H sql.h)
 add_header(HAVE_SQLEXT_H sqlext.h)
-foreach(fn char double float int short long "long double" "long long" "SQLWCHAR" "void *" wchar_t __int64
+foreach(fn char double float int short long "long double" "long long" "SQLWCHAR" "void *" wchar_t __int64 __int128
 	  SQLLEN SQLROWOFFSET SQLROWSETSIZE SQLSETPOSIROW)
 	string(REGEX REPLACE "[/. ]" "_" var "${fn}")
 	string(REPLACE "*" "P" var "${var}")
@@ -263,7 +271,7 @@
 	getaddrinfo inet_ntop gethostname poll socketpair
 	clock_gettime fseeko pthread_cond_timedwait pthread_cond_timedwait_relative_np
 	pthread_condattr_setclock _lock_file _unlock_file usleep nanosleep
-	readdir_r eventfd daemon system)
+	readdir_r eventfd daemon system mallinfo mallinfo2 _heapwalk)
 
 # TODO
 set(HAVE_GETADDRINFO 1 CACHE INTERNAL "")
@@ -346,25 +354,23 @@
 	config_write("#cmakedefine ENABLE_${flag} 1\n\n")
 endforeach(flag)
 
+if (ENABLE_MSDBLIB)
+	set(dblib_define "#define MSDBLIB 1")
+else()
+	set(dblib_define "#define SYBDBLIB 1")
+endif()
+
 config_write("#define VERSION \"\\@VERSION\\@\"\n\n")
 
 config_write("#define FREETDS_TOPDIR \"${FREETDS_TOPDIR}\"\n\n")
 
 # TODO allow to configure default TDS protocol version
 
-config_write("#ifdef _MSC_VER
+config_write("#if defined(_MSC_VER) && !defined(__cplusplus)
 #  define inline __inline
+#endif
+#if defined(_MSC_VER)
 #  define _CRT_SECURE_NO_WARNINGS 1
 #endif\n\n")
 
 if(WIN32)
-	config_write("/* Define to 1 if you want to use SSPI for Win32 */\n#define HAVE_SSPI 1\n\n")
-	config_write("/* define to format string used for 64bit integers */\n#define TDS_I64_PREFIX \"I64\"\n\n")
-	config_write("/* Define to 1 if you have the SQLGetPrivateProfileString function. */\n#define HAVE_SQLGETPRIVATEPROFILESTRING 1\n\n")
-	if(MINGW)
-		config_write("#define _GNU_SOURCE 1\n\n")
-	endif(MINGW)
-
-else(WIN32)
-	# this section make just work on Linux, many definition are not checked
-	config_write("#define HAVE_FUNC_GETPWUID_R_5 1\n\n")

=== src/utils/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,10 @@
 	threadsafe.c
 	bjoern-utf8.c
 	tdsstring.c
+	strndup.c
 	net.c
+	smp.c
+	path.c
 	${add_SRCS}
 )
 if (NOT WIN32)

=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+ds" \
  ftp://ftp.freetds.org/pub/freetds/stable/freetds-([0-9].*)\.tar\.gz
